//
//  ChooseCarPlateView.m
//  CarPlateKeyBoard
//
//  Created by FuYunLei on 2017/4/18.
//  Copyright © 2017年 FuYunLei. All rights reserved.
//

#import "ChooseCarPlateView.h"

#define FYLColorFromHexadecimalRGB(rgbValue) [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:1.0]
#define FYLColorFromRGB(r, g, b) [UIColor colorWithRed:r/255.0 green:g/255.0 blue:b/255.0 alpha:1]
#define FYLColorFromRGBA(r, g, b, a) [UIColor colorWithRed:r/255.0 green:g/255.0 blue:b/255.0 alpha:a]

#define SCREEN_WIDTH [UIScreen mainScreen].bounds.size.width     //屏幕宽度
#define SCREEN_HEIGHT [UIScreen mainScreen].bounds.size.height    //屏幕高度
#define Scale (SCREEN_WIDTH/375.f)
#define Height_Top 52*Scale
#define Height_Bottom 206*Scale

@interface ChooseCarPlateView ()
{
    int _index;
}

@property (nonatomic,strong)NSMutableString *strCarNumber;

@property (nonatomic,strong)UIView *viewTop;
@property (nonatomic,strong)UIView *viewBottom;

@property (nonatomic,strong)NSMutableArray *arrBtnTop;
@property (nonatomic,strong)NSMutableArray *arrBtnBottom;

@property (nonatomic,weak)UIButton *btnLastClicked;

@property (nonatomic,strong)NSDictionary *dicBtnTitles;

//show
@property (nonatomic,strong)UIWindow *window;
@property (nonatomic,strong)UITapGestureRecognizer *gesture;
@property (nonatomic,strong)UIView *view;

@end

@implementation ChooseCarPlateView

- (instancetype)init
{
    if (self = [super init]) {
        self.backgroundColor = FYLColorFromHexadecimalRGB(0xf5f5f5);
        _index = 0;
        [self initDic];
        [self createTopViewAndBottomView];
        [self addBtnToArr];
    }
    return self;
}
- (void)initDic
{
    self.dicBtnTitles = @{
                          @"0":@[@"京",@"津",@"晋",@"冀",@"蒙",@"辽",@"吉",@"黑",@"沪",@"苏",@"浙",@"皖",@"闽",@"赣",@"鲁",@"鄂",@"武",@"湘",@"粤",@"桂",@"琼",@"川",@"贵",@"云",@"藏",@"陕",@"甘",@"青",@"宁",@"新",@"渝",@"豫",@"V",@"Z",@"E",@"K",@"H",@"B",@"S",@"L",@"J",@"N",@"G",@"C"],
                          @"1":@[@"A",@"B",@"C",@"D",@"E",@"F",@"G",@"H",@"I",@"J",@"K",@"L",@"M",@"N",@"O",@"P",@"Q",@"R",@"S",@"T",@"U",@"V",@"W",@"X",@"Y",@"Z"],
                          @"2":@[@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8",@"9",@"0",@"A",@"B",@"C",@"D",@"E",@"F",@"G",@"H",@"I",@"J",@"K",@"L",@"M",@"N",@"O",@"P",@"Q",@"R",@"S",@"T",@"U",@"V",@"W",@"X",@"Y",@"Z"],
                          @"3":@[@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8",@"9",@"0",@"A",@"B",@"C",@"D",@"E",@"F",@"G",@"H",@"I",@"J",@"K",@"L",@"M",@"N",@"O",@"P",@"Q",@"R",@"S",@"T",@"U",@"V",@"W",@"X",@"Y",@"Z"],
                          @"4":@[@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8",@"9",@"0",@"A",@"B",@"C",@"D",@"E",@"F",@"G",@"H",@"I",@"J",@"K",@"L",@"M",@"N",@"O",@"P",@"Q",@"R",@"S",@"T",@"U",@"V",@"W",@"X",@"Y",@"Z"],
                          @"5":@[@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8",@"9",@"0",@"A",@"B",@"C",@"D",@"E",@"F",@"G",@"H",@"I",@"J",@"K",@"L",@"M",@"N",@"O",@"P",@"Q",@"R",@"S",@"T",@"U",@"V",@"W",@"X",@"Y",@"Z"],
                          @"6":@[@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8",@"9",@"0",@"A",@"B",@"C",@"D",@"E",@"F",@"G",@"H",@"I",@"J",@"K",@"L",@"M",@"N",@"O",@"P",@"Q",@"R",@"S",@"T",@"U",@"V",@"W",@"X",@"Y",@"Z",@"警",@"学",@"挂",@"港",@"澳"]};
}
- (void)addBtnToArr
{
    _arrBtnTop = [NSMutableArray arrayWithCapacity:7];
    for (int i = 0; i<7; i++) {
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        [btn setFrame:CGRectMake(i*SCREEN_WIDTH/7.f, 0, SCREEN_WIDTH/7.f, Height_Top)];
        btn.backgroundColor = [UIColor clearColor];
        btn.tag = i;
        [btn setTitleColor:FYLColorFromHexadecimalRGB(0x2f2f2f) forState:UIControlStateNormal];
        [btn setTitleColor:FYLColorFromHexadecimalRGB(0xefefef) forState:UIControlStateHighlighted];
        [btn addTarget:self action:@selector(topBtnClicked:) forControlEvents:UIControlEventTouchUpInside];
        [_arrBtnTop addObject:btn];
        [_viewTop addSubview:btn];
        if (i == 0) {
            _btnLastClicked = btn;
            _btnLastClicked.backgroundColor = FYLColorFromHexadecimalRGB(0xfecb16);
        }
    }
    
    _arrBtnBottom = [NSMutableArray arrayWithCapacity:45];
    
    CGFloat btnW = (SCREEN_WIDTH - 8)/9.f;
    CGFloat btnH = (Height_Bottom - 4)/5.f;
    
    for (int i = 0; i<45; i++) {
        int hang = i/9;
        int lie = i%9;
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        [btn setFrame:CGRectMake(lie*(btnW+1), hang*(btnH + 1), btnW, btnH)];
        btn.backgroundColor = [UIColor whiteColor];
        [btn setTitleColor:FYLColorFromHexadecimalRGB(0x2f2f2f) forState:UIControlStateNormal];
        [btn setTitleColor:FYLColorFromHexadecimalRGB(0xefefef) forState:UIControlStateHighlighted];
        [btn addTarget:self action:@selector(btnClicked:) forControlEvents:UIControlEventTouchUpInside];
        [_arrBtnBottom addObject:btn];
    }
}
- (void)createTopViewAndBottomView
{
    _viewTop = [[UIView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH, Height_Top)];
    _viewTop.backgroundColor = [UIColor whiteColor];
    [self addSubview:_viewTop];
    
    _viewBottom = [[UIView alloc] initWithFrame:CGRectMake(0, Height_Top + 10, SCREEN_WIDTH, Height_Bottom)];
    _viewBottom.backgroundColor = FYLColorFromHexadecimalRGB(0xf5f5f5);
    [self addSubview:_viewBottom];
}
- (void)setStrDefault:(NSString *)strDefault
{
    if (_strDefault != strDefault) {
        _strDefault = strDefault;
    }
    
    if (_strDefault != nil) {
        self.strCarNumber = [NSMutableString stringWithString:_strDefault];
    }else
    {
        self.strCarNumber = [NSMutableString stringWithString:@"."];
    }
    while (self.strCarNumber.length != 7) {
        //         NSLog(@"===(%@) lenth = %zi",self.strCarNumber,self.strCarNumber.length);
        [self.strCarNumber appendString:@"."];
    }
    
    _index = (int)_strDefault.length;
    if (_index == 7) {
        _index = 0;
    }
    
}
- (void)layoutTopView
{
    for (UIButton *btn in _arrBtnTop) {
        [btn setSelected:NO];
        btn.backgroundColor = [UIColor clearColor];
    }
    
    for (int i = 0; i<_strCarNumber.length; i++) {
        NSString *str = [_strCarNumber substringWithRange:NSMakeRange(i, 1)];
        UIButton *btn = _arrBtnTop[i];
        if ([str isEqualToString:@"."]) {
            [btn setTitle:@"" forState:UIControlStateNormal];
        }else
        {
            [btn setTitle:str forState:UIControlStateNormal];
        }
    }
    
    _btnLastClicked = _arrBtnTop[_index];
    _btnLastClicked.selected = YES;
    _btnLastClicked.backgroundColor = FYLColorFromHexadecimalRGB(0xfecb16);
}

- (void)layoutBottomView
{
    for (UIButton *btn in _arrBtnBottom) {
        [btn removeFromSuperview];
    }
    
    for ( int i = 0; i<_arrBtnBottom.count;i++) {
        NSArray *titles = [_dicBtnTitles objectForKey:[NSString stringWithFormat:@"%zi",_btnLastClicked.tag]];
        
        UIButton *btn = _arrBtnBottom[i];
        if (i<titles.count) {
            
            [btn setTitle:titles[i] forState:UIControlStateNormal];
            [_viewBottom addSubview:btn];
            
        }
    }
}

- (void)btnClicked:(UIButton *)btn
{
    NSString *str = btn.currentTitle;
    
    NSInteger index = _btnLastClicked.tag;
    
    [self.strCarNumber replaceCharactersInRange:NSMakeRange(index, 1) withString:str];
    _index ++;
    
    
    if (_index == 7) {
        _index = 0;
    }
    
    [self layoutTopView];
    [self layoutBottomView];
    
    if (index == 6) {
        [self isClose];
    }
}

- (void)topBtnClicked:(UIButton *)btn
{
    if (btn != _btnLastClicked) {
        _index = (int)btn.tag;
        _btnLastClicked.selected = NO;
        _btnLastClicked.backgroundColor = [UIColor clearColor];
        
        btn.selected = YES;
        btn.backgroundColor = FYLColorFromHexadecimalRGB(0xfecb16);
        
        _btnLastClicked = btn;
        
        [self layoutBottomView];
    }
}
- (void)show
{
    
    [self layoutTopView];
    [self layoutBottomView];
    
    _window = [UIApplication sharedApplication].keyWindow;
    //给window加点击手势关闭self
    _gesture = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(tapAction:)];
    [_window addGestureRecognizer:_gesture];
    _view = [[UIView alloc]initWithFrame:_window.bounds];
    _view.backgroundColor = FYLColorFromRGBA(0, 0, 0, 0.2);
    [_window addSubview:_view];
    [_window addSubview:self];
    self.frame = CGRectMake(0, SCREEN_HEIGHT, SCREEN_WIDTH, 258*Scale + 10);
    
    [UIView animateWithDuration:0.3 animations:^{
        self.frame = CGRectMake(0, SCREEN_HEIGHT - 258*Scale - 10, SCREEN_WIDTH, 258*Scale + 10);
    }];
}

- (void)tapAction:(UITapGestureRecognizer *)tap
{
    CGPoint p = [tap locationInView:self];
    
    if (p.y < 0 ) {
        [self close];
    }
}
///判断是否选择完成
- (void)isClose
{
    if ([self.strCarNumber containsString:@"."]) {
        return;
    }else
    {
        [self close];
    }
}
-(void)close{
    
    if (self.didChooseCarNumberBlock != nil) {
        [self.strCarNumber replaceOccurrencesOfString:@"." withString:@"" options:NSCaseInsensitiveSearch range:NSMakeRange(0, self.strCarNumber.length)];
        self.didChooseCarNumberBlock(self.strCarNumber);
    }
    //移除点击手势
    [_window removeGestureRecognizer:_gesture];
    _gesture = nil;
    [UIView animateWithDuration:0.2 animations:^{
        self.frame = CGRectMake(0, SCREEN_HEIGHT, SCREEN_HEIGHT, 258*Scale + 10);
    } completion:^(BOOL finished) {
        [_view removeFromSuperview];
    }];
}

@end
